#ifndef GLASSERT
#define GLASSERT

/**
 * OpenGL error management class.
 */

#include <cstdio>
#include <cassert>

#ifdef RENDER_DEBUG
#define STR(x) #x
#define glAssert(code) \
    code; \
{\
    GLuint err = glGetError(); \
    if(err != GL_NO_ERROR){ \
        fprintf(stderr, "OpenGL Error (%s : %d, %s) : %s (%d)\n", __FILE__, __LINE__, STR(code), gluErrorString(err), err);\
    } \
}
#else
#define glAssert(code) code;
#endif

#endif // GLASSERT

