#include "pipeline.h"
#include "forwardmodule.h"
#include "crappymodule.h"
#include "shadersource.h"
#include "sparrowrenderer.h"
#include "scene.h"

Pipeline::~Pipeline()
{
    for(Module *m : modules)
        delete m;
}

SimplePipeline::SimplePipeline(ShaderSource *forwardSource)
{
    isCrappy = forwardSource != NULL && SparrowRenderer::isModernOpenGLAvailable();
    if(!isCrappy)
    {
        ForwardModule *forward = new ForwardModule();
        forward->setShaderSource(forwardSource);
        forward->setClearBeforeDrawing(false);
        modules.push_back(forward);
    }
    else
        modules.push_back(new CrappyModule());
}

void SimplePipeline::refreshScene(Scene *scene)
{
    if(!isCrappy)
    {
        ForwardModule *forward = (ForwardModule*)(modules[0]);
        forward->compileShaders(scene);
    }
}

DefaultPipeline::DefaultPipeline(const Settings &mySettings, const SourcePack &mySourcePack)
{

}
